<template>
  <div class="app-container">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">

      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="date"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="date"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="用户来源">
        <el-select
          v-model="queryParams.source"
          class="filter-item"
          placeholder="用户来源"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in sourceData"
            :key="item.source"
            :label="item.name"
            :value="item.source"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="瓦力ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.wuid" placeholder="请输入" />
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>

    <el-table :data="tableData" style="width:100%"  class="show_table"  >
      <el-table-column label="日期" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.period}}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户ID" style="width:30%" :show-overflow-tooltip="true" align="center" prop="openId">
        <template slot-scope="scope">
          <span>{{ scope.row.openId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="瓦力ID" style="width:30%" :show-overflow-tooltip="true" align="center" prop="wuid">
        <template slot-scope="scope">
          <span>{{ scope.row.wuid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="渠道" style="width:30%" :show-overflow-tooltip="true" align="center" prop="source">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="奖金" style="width:2%" prop="award" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.award }}</span>
        </template>
      </el-table-column>
      <el-table-column label="总首存" style="width:2%" prop="firstDepositNum" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.firstDepositNum }}</span>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import {getFirstDepReportList,getSourceList} from "@/api/firstDepositReport";
import {
  export_json_to_excel
} from "@/vendor/Export2Excel";
    export default {
        components: {

        },
        created() {
            this.getGameManagerList();
            this.sourceList();

        },

        data() {
            return {
                sourceData: [
                  {
                    name:'全选',
                    source:''}
                ],
                tableData: [],
                totalList: [],
                queryParams:{
                  beginCreateTime: new Date(), //创建时间-开始
                  endCreateTime: new Date(),
                  source: "",
                  wuid: "",
                },
                currentPage: 1,
                total: null,
                pageSize: 40,
                orderByDescColumn: "", // 降序字段
                orderByAscColumn: "", // 升序字段
            };
        },

        methods: {
          sourceList: function() {
            var sourceParams = {};
            sourceParams.pageSize = 1000;
            sourceParams.currentPage = 1;
            getSourceList(sourceParams).then(response => {
              this.sourceData.push(...response.data.records);
            });
          },
            getGameManagerList: function() {
                this.queryParams.currentPage = this.currentPage;
                this.queryParams.pageSize = this.pageSize;
                this.queryParams.orderByDescColumn = this.orderByDescColumn
                this.queryParams.orderByAscColumn = this.orderByAscColumn
              getFirstDepReportList(this.queryParams).then(response => {
                    this.tableData = response.data.records;
                    this.currentPage = response.data.current;
                    this.pageSize = response.data.size;
                    this.total = response.data.total;
                });
            },


            changeSort (val) {
                // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
                if(val.order == "ascending") {
                    this.orderByAscColumn = val.prop
                    this.orderByDescColumn = ""
                } else {
                    this.orderByAscColumn = ""
                    this.orderByDescColumn = val.prop
                }
                this.getGameManagerList();
            },

            handleFind: function() {
                this.currentPage = 1
                this.getGameManagerList();
            },
            /**
             * 翻页事件
             */
            handleSizeChange(val) {
                this.pageSize = val;
                this.getGameManagerList();
            },
            //改变页码
            handleCurrentChange(val) {
                this.currentPage = val;
                this.getGameManagerList();
            },
          // 导出excel数据
          exportData() {
            // 表头对应关系
            const headers = {
              '日期': 'period',
              '用戶ID': 'openId',
              '瓦力ID': 'wuid',
              '渠道': 'sourceName',
              '奖金': 'award',
              '总首存': 'firstDepositNum',
            }
            this.queryParams.currentPage = 1;
            this.queryParams.pageSize = -1;
            this.queryParams.orderByDescColumn = this.orderByDescColumn
            this.queryParams.orderByAscColumn = this.orderByAscColumn
            getFirstDepReportList(this.queryParams).then(response => {
              const records = response.data.records;
              if(this.totalList.length>0){
                const totalInfo = new Map();
                totalInfo.set("period",this.totalList[0]);
                totalInfo.set("openId",this.totalList[1]);
                totalInfo.set("wuid",this.totalList[2]);
                totalInfo.set("sourceName",this.totalList[3]);
                totalInfo.set("award",this.totalList[4]);
                totalInfo.set("firstDepositNum",this.totalList[5]);
                records.push(this.mapToObj(totalInfo));
              }
              const data = this.formatJson(headers, response.data.records)
              export_json_to_excel(Object.keys(headers), data, '首存活动报表')
            });
          },
          // 该方法负责将数组转化成二维数组
          formatJson(headers, rows) {
            // 首先遍历数组
            return rows.map(item => {
              return Object.keys(headers).map(key => {
                return item[headers[key]]
              })
            })
          },
          mapToObj(map){
            var obj = {};
            for(let [key,value] of map){
              obj[key] = value;
            }
            return obj;
          },
        }
    }
</script>

